# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetHelmRepositoryResult',
    'AwaitableGetHelmRepositoryResult',
    'get_helm_repository',
    'get_helm_repository_output',
]

@pulumi.output_type
class GetHelmRepositoryResult:
    """
    A collection of values returned by getHelmRepository.
    """
    def __init__(__self__, description=None, id=None, kind=None, name=None, organization_id=None, skip_tls_verification=None, url=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if kind and not isinstance(kind, str):
            raise TypeError("Expected argument 'kind' to be a str")
        pulumi.set(__self__, "kind", kind)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)
        if skip_tls_verification and not isinstance(skip_tls_verification, bool):
            raise TypeError("Expected argument 'skip_tls_verification' to be a bool")
        pulumi.set(__self__, "skip_tls_verification", skip_tls_verification)
        if url and not isinstance(url, str):
            raise TypeError("Expected argument 'url' to be a str")
        pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def kind(self) -> str:
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter(name="skipTlsVerification")
    def skip_tls_verification(self) -> bool:
        return pulumi.get(self, "skip_tls_verification")

    @property
    @pulumi.getter
    def url(self) -> str:
        return pulumi.get(self, "url")


class AwaitableGetHelmRepositoryResult(GetHelmRepositoryResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetHelmRepositoryResult(
            description=self.description,
            id=self.id,
            kind=self.kind,
            name=self.name,
            organization_id=self.organization_id,
            skip_tls_verification=self.skip_tls_verification,
            url=self.url)


def get_helm_repository(description: Optional[str] = None,
                        id: Optional[str] = None,
                        kind: Optional[str] = None,
                        name: Optional[str] = None,
                        organization_id: Optional[str] = None,
                        skip_tls_verification: Optional[bool] = None,
                        url: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetHelmRepositoryResult:
    """
    ## # HelmRepository (Data Source)

    Provides a Qovery helm repository resource. This can be used to create and manage Qovery helm repository.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_qovery as qovery

    my_helm_repository = qovery.get_helm_repository(id="<helm_repository_id>",
        organization_id="<organization_id>")
    ```
    """
    __args__ = dict()
    __args__['description'] = description
    __args__['id'] = id
    __args__['kind'] = kind
    __args__['name'] = name
    __args__['organizationId'] = organization_id
    __args__['skipTlsVerification'] = skip_tls_verification
    __args__['url'] = url
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('qovery:index/getHelmRepository:getHelmRepository', __args__, opts=opts, typ=GetHelmRepositoryResult).value

    return AwaitableGetHelmRepositoryResult(
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        kind=pulumi.get(__ret__, 'kind'),
        name=pulumi.get(__ret__, 'name'),
        organization_id=pulumi.get(__ret__, 'organization_id'),
        skip_tls_verification=pulumi.get(__ret__, 'skip_tls_verification'),
        url=pulumi.get(__ret__, 'url'))


@_utilities.lift_output_func(get_helm_repository)
def get_helm_repository_output(description: Optional[pulumi.Input[Optional[str]]] = None,
                               id: Optional[pulumi.Input[str]] = None,
                               kind: Optional[pulumi.Input[Optional[str]]] = None,
                               name: Optional[pulumi.Input[Optional[str]]] = None,
                               organization_id: Optional[pulumi.Input[str]] = None,
                               skip_tls_verification: Optional[pulumi.Input[Optional[bool]]] = None,
                               url: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetHelmRepositoryResult]:
    """
    ## # HelmRepository (Data Source)

    Provides a Qovery helm repository resource. This can be used to create and manage Qovery helm repository.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_qovery as qovery

    my_helm_repository = qovery.get_helm_repository(id="<helm_repository_id>",
        organization_id="<organization_id>")
    ```
    """
    ...
